
#include <string.h>	
#include <avr/pgmspace.h>
#include <ctype.h>

#include "main.h"
#include "command.h"
#include "file.h"
#include "fat.h"
#include "hardware.h"

char command[5];	// commando (größtes : "cd..")
char data[13];		// maximal 8.3 bei datei namen !
 
// *****************************************************************************************************************
// zeigt commando prompt an, ist endloschleife.
// es können alle fat funktionen hier getestet werden (bis auf ffseek). liest wahlweise uber uart oder angeschlossene
// tastatur ein (siehe kb-0.x.h für die pins die angeschlossen werden müssen).
/**
run_cmd handhabung: 

-wenn datei mit "or" zum lesen geöffnet, kann mit ls der inhalt ausgegeben werden. die datei muss mit "c"
geschlossen werden um andere operationen auszuführen. 

-wenn datei mit "ow" zum schreiben geöffnet ist kann mit "w" in die datei geschrieben werden, abbruch zeichen ist "ESC"-taste. 
die datei muss mit "c" geschlossen werden um andere operationen auszuführen. 
die datei muss erst geschlossen werden um sie zu lesen.

-wenn datei mit "oa" zum anhängen geöffnet ist, kann mit "w" an die datei angehangen werden, abbruch zeichen ist "ESC"-taste.
die datei muss mit "c" geschlossen werden um andere operationen auszuführen. 
die datei muss erst geschlossen werden um sie zu lesen.

-"rm datei" löscht datei mit dem namen "datei" aus aktuellem verzeichniss, wenn es die datei gibt.
löschen von ordner noch nicht vorgesehen, da man diese rekursiv löschen müsste.

-"cd dirname" wechselt in verzeichniss "dirname". immer nur ein verzeichniss. "cd dir1/dir2" geht nicht !

-"cd.." wechselt in parent verzeichniss.

-"ls" ohne vorherige datei operation zeigt ordner inhalt an. "ls" wenn "or" dann wird datei inhalt angezeigt.

-mit "q" wird run_cmd beendet !
*/
// *****************************************************************************************************************
unsigned char run_cmd(void){						
    
  char flag=0;							// flag für or,ow usw...
  unsigned char c;					// zum zeichenweise einlesen.
  unsigned char i;					// zähler für die eingelesenen zeichen.
  unsigned long int seek=0;			// für seek in datei.. beim lesen oder überschreiben	
  
  char directory[30]="dan:";		// enthält dir namen oder datei namen wenn zum lesen/anhängen/schreiben geöffnet.    

  do{
	uputs((unsigned char*)"\n");		// neue zeile. 	
	uputs((unsigned char*)directory); 	// zeigt dir an. 	
	uputs((unsigned char*)" >:");		// command prompt.	

	i=0;
	c=0;

	while(c!=13 && i<15){				// liest zeichen ein, maximal 15 oder bis RETURN gedrückt.			 
	  c=ugetc();						// wartet auf zeichen eingabe über uart.		  	  
	  uputc(c);							// gibt zeichen aus auf uart.
	  buffer[i]=c;						// speichern von zeichen auf puffer.
	  i++;								// zähler anzahl eingelesene zeichen.
	  }
	buffer[i-1]='\0';					// terminiert cmd_str, weil abbruch zeichen noch gespeichert wird.
	c=0;
	
	cmd_data(buffer);					// teilt string in befehl und parameter(daten) auf.

		// cd ************************************************************************************************* 
		if(0==strcmp(command,"cd")&&flag==0){		// befehl cd erkannt			  
			strcat(directory,"/"); 						// kopiert "/" auf directory string.									
			strcat(directory,data);						// kopiert dir namen auf directory string.  		
			if(0==ffcd(fat_str(data))){					// wechselt in directory. 	
			  c=0;										// ist c==0 wird das dir auch tatsächlich angezeigt
			  }	
			else {c=1;}			  
			}
		  
		// cd.. *************************************************************************************************
		if(0==strcmp(command,"cd..")&&flag==0){	// befehl cd.. erkannt	
		  if(0==ffcdLower()) {								// geht in partent dir 
			c=1;
 			}	
		  }	

#ifndef __AVR_ATmega8__
		// rm *************************************************************************************************
		if(0==strcmp(command,"rm")&&flag==0){		// befehl remove erkannt			  
			if(0==ffrm(fat_str(data))){				// löscht datei/ordner (ordner rekursiv).
			  }	
			}


		// md ************************************************************************************************* 
		if(0==strcmp(command,"md")&&flag==0){		// befehl make directory erkannt			 						
			ffmkdir(fat_str(data));						// legt directory an.			 
			}
 	
#endif

		// op *************************************************************************************************
		if(0==strcmp(command,"op")&&flag==0){		// befehl open erkannt (anlegen oder nur öffnen). set flag=1	  
			strcat(directory,"/");						// kopiert "/" auf directory string.									
			strcat(directory,data);						// kopiert datei namen auf directory string. 	 		
			ffopen(fat_str(data));
			c=0;
 			flag=1;											// flag==1 -> datei operation			
			}	
	
		 // sk *************************************************************************************************
		if(0==strcmp(command,"sk")&&flag==1){		// befehl seek erkannt. zum vor und zurück spulen in der datei		
		  uputs("OK");
		  seek=atol(data);		  
		  ffseek(seek);
		  }
		
		// w *************************************************************************************************
		if(0==strcmp(command,"w")&&flag==1){		// befehl write erkannt.
			unsigned char c;								//schreibt bei open to write und open to append
			uputs((unsigned char*)"\n>\n");			
			do{				
				c=ugetc();									// liest byte ein (von uart).
				if(c==27)break;							// abbruch nur wenn ESC gedrückt.
				ffwrite(c);									// schreibt byte auf karte.
				uputc(c);									// echo von byte auf uart.
				}while(1);			
			uputs((unsigned char*)"\n<");			
			}

		// c *************************************************************************************************
		if(0==strcmp(command,"c")&&flag==1){		// befehl close erkannt				
			ffclose();
			flag=0;				
			c=1;			
			}

		// ls *************************************************************************************************
		if(0==strcmp(command,"ls")){					// befehl ls , 2 optionen: 1==datei inhalt, 0==directory anzeigen.
		  uputs((unsigned char*)"\n");
		  if(flag==1){										// datei zum lesen geöffnet !
			if(file.length>0){								// prüfen ob daten in datei ! sonnst ist while(--seek) nie wahr!
				seek=file.length-seek;
				do{											// wiederholt so lange wie bytes da sind.						
				  uputc(ffread());							// zeigt gelesenes byte auf uart				  				
				}while(--seek);								// solange bytes da sind		
				seek=0;
				ffseek(0);
				uputs((unsigned char*)"\n");
			  }
			}
		  if(flag==0){										// directory anzeigen
			if(0==ffls());									// zeigt kompletten directory inhalt an !					
			}
		  }
		
		if(c==1){											// wenn c==1 dann wird die anzeige gelöscht	
		  char *ptr;										// zeigt auf letzte stelle an der / vorkommt	
		  ptr=strrchr(directory,'/');						// letztes vorkommen von /
		  *ptr = '\0' ;										// stelle von letztem / wird mit \0 überschrieben	
		  }



  }while(1);
  return (0);
}



// *****************************************************************************************************************
// bereitet str so auf, dass man es auf die mmc/sd karte schreiben kann.
// wandelt z.b. "t.txt" -> "T        TXT"
// VORSICHT es werden keine Prüfungen gemacht !
// *****************************************************************************************************************
char * fat_str(char *str){

  unsigned char i;
  unsigned char j=0;
  unsigned char c;
  char tmp[12];					// tmp string zum einfacheren umwandeln
  
  strcpy(tmp,str);

  for(i=0;i<11;i++)str[i]=' ';
  str[11]='\0';

  i=0;

  do{
	c=toupper(tmp[j]);
	if(c=='\0')return str;
	if(c!='.')str[i]=c;
	else i=7;
	i++;
	j++;
	}while(i<12);

  return str;
  
}



// *****************************************************************************************************************
// teilt string auf in commando und parameter(daten).
// z.b. "cd dir1" -> command=="cd" data=="dir1"
// VORSICHT, es werden keine Prüfungen gemacht!
// *****************************************************************************************************************
void cmd_data(char *string){

  char *tmp;
  
  strcpy(command,strtok_r(string, " ", &tmp ));  
  strcpy(data,strtok_r( NULL, " ", &tmp )); 

}

